Index: trunk/gsdl/macros/base.dm
===================================================================
--- trunk/gsdl/macros/base.dm	(revision 11990)
+++ trunk/gsdl/macros/base.dm	(revision 11999)
@@ -181,4 +181,5 @@
 _httppagetranslator_ {_gwcgi_?e=_compressedoptions_&amp;a=gti&amp;p=home}
 _httppagecollector_ {_gwcgi_?e=_compressedoptions_&amp;a=collector&amp;p=intro}
+_httppagedepositor_ {_gwcgi_?e=_compressedoptions_&amp;a=depositor&amp;p=select}
 _httppagegli_ {_httppagex_(gli)}
 _httppageabout_ {_httppagex_(about)}
@@ -204,4 +205,6 @@
 _httpdoc_  {_gwcgi_?e=_compressedoptions_&amp;a=d}
 
+_httpdocumenthandle_ {_httpprefix_handle/_1_/_2_}
+
 _httpextlink_ {_gwcgi_?e=_compressedoptions_&amp;a=extlink}
 _httpbuild_ {_gwcgi_?e=_compressedoptions_&amp;a=bc}
Index: trunk/gsdl/macros/collect.dm
===================================================================
--- trunk/gsdl/macros/collect.dm	(revision 11990)
+++ trunk/gsdl/macros/collect.dm	(revision 11999)
@@ -182,19 +182,19 @@
 
 <p>_texttsosn_
-<table class=collectorbar cellspacing=6>
+<table class=wizardbar cellspacing=6>
 <tr><td width=20 align=right valign=bottom>1.</td>
-    <td class=collectorbargrey valign=bottom>_textinfo_</td>
+    <td class=wizardbargrey valign=bottom>_textinfo_</td>
     <td valign=bottom>_textsin_</td></tr>
 <tr><td align=right valign=bottom>2.</td>
-    <td class=collectorbargrey valign=bottom>_textsrce_</td>
+    <td class=wizardbargrey valign=bottom>_textsrce_</td>
     <td valign=bottom>_textswts_</td></tr>
 <tr><td align=right valign=bottom>3.</td>
-    <td class=collectorbargrey valign=bottom>_textconf_</td>
+    <td class=wizardbargrey valign=bottom>_textconf_</td>
     <td valign=bottom>_textatco_</td></tr>
 <tr><td align=right valign=bottom>4.</td>
-    <td class=collectorbargrey valign=bottom>_textbild_</td>
+    <td class=wizardbargrey valign=bottom>_textbild_</td>
     <td valign=bottom>_textbtc_</td></tr>
 <tr><td align=right valign=bottom>5.</td>
-    <td class=collectorbargrey valign=bottom>_textview_</td>
+    <td class=wizardbargrey valign=bottom>_textview_</td>
     <td valign=bottom>_textpvyh_</td></tr>
 </table>
Index: trunk/gsdl/macros/deposit.dm
===================================================================
--- trunk/gsdl/macros/deposit.dm	(revision 11999)
+++ trunk/gsdl/macros/deposit.dm	(revision 11999)
@@ -0,0 +1,701 @@
+# this file must be UTF-8 encoded
+
+package depositor
+
+_imagethispage_ {<a href="_httppagedepositor_">_textdepositor_</a>}
+
+# _pagescriptextra_ will be set to the appropriate _***scriptextra_
+# macro from within the server
+_pagescriptextra_ {}
+
+# a plain header for those pages that need it (the _pagebanner_ macro
+# will be set to this by the server for those pages.
+_plainbanner_ {}
+
+# dont want links to help" or "preferences" pages from within
+# collector
+_globallinks_ {_homelink_}
+
+#######################################################################
+# steps
+
+_numsteps_ {3}
+
+# clashes with general text (in english2.dm) about what to do at this stage
+# now it doesn't appear in wizard bar, is it needed?
+##_textselect_ {The Depositor}
+_textstep1_ {_textmeta_}
+_textstep2_ {_textintro_}
+_textstep3_ {Confirmation}
+
+_laststep_ {bild}
+_textlaststep_ {_textbild_}
+
+
+#######################################################################
+# icons
+
+_iconcross_ {<img src="_httpimg_/cross.gif">}
+_iconcross_ [v=1] {<b>no</b>}
+_icontick_ {<img src="_httpimg_/tick.gif">}
+_icontick_ [v=1] {<b>yes</b>}
+_iconblank_ {<img src="_httpimg_/blank.gif">}
+_iconblank_ [v=1] {}
+
+_imagemore_ {<a href="javascript:more()" onMouseover="roll('more',1);" onMouseOut="roll('more',0);"><img
+name="more" src="_httpimg_/moreof.gif" onLoad="gbutton(this,'_httpimg_/moreon.gif');" border=0 alt="_textmore_"
+title="_textmore_" align=top></a>}
+_imagemore_ [v=1] {_textmore_}
+
+_icongreyarrow_ {<img src="_httpimg_/grarrow.gif">}
+_icongreyuparrow_ {<img src="_httpimg_/guarrow.gif">}
+_iconstop_ {<img src="_httpimg_/stop.gif" border=0>}
+
+
+#######################################################################
+# http macros 
+
+_httpinfo_ {_gwcgi_?e=_compressedoptions_&p=info}
+_httpsrce_ {_gwcgi_?e=_compressedoptions_&p=srce}
+_httpconf_ {_gwcgi_?e=_compressedoptions_&p=conf}
+_httpbild_ {_gwcgi_?e=_compressedoptions_&p=bild}
+_httpview_ {_gwcgi_?a=p&p=about&c=_cgiargdi1dirname_}
+_httpdel_  {javascript:do\_delete();}
+_httpexpt_ {_gwcgi_?e=_compressedoptions_&p=expt}
+
+
+#######################################################################
+# select // this really should be intro
+#######################################################################
+
+_selectscriptextra_ {
+
+function check\_submit (gotopage) \{
+  var form = document.depositorform;
+  form.p.value = gotopage;
+
+  // if 'dirname' given, then link to cgiarg c so collection specific macros work
+  if (form.di1dirname) \{
+    form.c.value = form.di1dirname.value;
+  \}
+
+  form.submit();
+\}
+
+function menuchange() \{
+
+  _buildtypearray_
+
+  var form = document.depositorform;
+
+  if (form.di1dirname.value == "") \{
+    alert("Please choose a collection first");
+  \}
+  else \{
+    var pos = form.di1dirname.selectedIndex;
+    var bt = buildtype[pos];
+    if (bt=="") \{ bt = "mg"; \}
+    form.di1buildtype.value = bt;
+
+    check\_submit('step1');  
+  \}
+\}
+
+}
+
+_selectcontent_ {
+<form name="depositorform" method=post action="_gwcgi_">
+<input type=hidden name="e" value="_decodedcompressedoptions_">
+<input type=hidden name="p" value="intro">
+<input type=hidden name="c" value="">
+<input type=hidden name="di1buildtype" value="">
+
+<center>
+<table width=_pagewidth_>
+<tr><td>
+<div class="divbar">&nbsp;</div>
+<center><h2>_textselect_</h2></center>
+<div class="divbar">&nbsp;</div>
+
+<p> <em>Select the collection to which you would like to add a new 
+document. </em>
+
+<p>_fullnamemenu_<br><br>
+<div class="divbar">&nbsp;</div>
+</td></tr>
+</table>
+</center>
+</form>
+}
+
+
+#######################################################################
+# step 1
+#######################################################################
+
+#here goes the "memorization" macros for each form field.  
+_di1md.dc.Title_ {_If_("_:cgiargdi1md.dc.Title_" eq  "_cgiargdi1md.dc.Title_",_cgiargdi1md.dc.Title_,)}
+_di1md.dc.Creator_ {_If_("_:cgiargdi1md.dc.Creator_" eq  "_cgiargdi1md.dc.Creator_",_cgiargdi1md.dc.Creator_,)}
+_di1md.dc.Description_ {_If_("_:cgiargdi1md.dc.Description_" eq  "_cgiargdi1md.dc.Description_",_cgiargdi1md.dc.Description_,)}
+
+_step1scriptextra_ {
+
+function check\_submit (gotopage) \{
+  var form = document.depositorform;
+  form.p.value = gotopage;
+  form.submit();
+\}
+}
+
+_step1content_ {
+
+<form name="depositorform" method=post action="_gwcgi_" enctype="multipart/form-data">
+
+<input type=hidden name="e" value="_decodedcompressedoptions_">
+<input type=hidden name="p" value="_cgiargp_">
+
+<center>
+<table width=_pagewidth_>
+<tr><td>
+<div class="divbar">&nbsp;</div>
+<center>
+<h2>_textstep1_</h2>
+<p>_textdepositorblurb_
+</center>
+<div class="divbar">&nbsp;</div>
+<ul>
+
+<!--input goes here-->
+<p><table>
+<tr>
+  <td>Title:</td>
+  <td> <input type=text name=di1md.dc.Title value="_di1md.dc.Title_" size=74></td>
+</tr>
+<tr>
+  <td>Creator:</td>
+  <td><input type=text name=di1md.dc.Creator value = "_di1md.dc.Creator_" size=74></td>
+</tr>
+<tr>
+  <td>Description:</td>
+  <td> <textarea rows=5 cols=40 name=di1md.dc.Description>_di1md.dc.Description_</textarea></td>
+
+</tr>
+</table>
+
+<!--
+<BR>
+<BR>
+<p>Description: <textarea rows=5 cols=20 name=di1md.dc.Description>_di1md.dc.Description_</textarea></p>
+</ul>
+-->
+
+<div class="divbar">&nbsp;</div>
+</td></tr>
+<tr><td>_depositorbar_</td></tr>
+</table></center>
+
+</form>
+
+}
+
+#######################################################################
+# step 2
+#######################################################################
+
+_userfile_ {_If_("_:cgiargdi1userfile_" eq  "_cgiargdi1userfile_",_cgiargdi1userfile_,)}
+
+_step2scriptextra_ {
+
+function check\_submit (gotopage) \{
+  var form = document.depositorform;
+  form.p.value = gotopage;
+  form.submit();
+\}
+}
+
+_step2content_ {
+<form name="depositorform" method=post action="_gwcgi_" enctype="multipart/form-data">
+<input type=hidden name="e" value="_decodedcompressedoptions_">
+<input type=hidden name="p" value="_cgiargp_">
+<center>
+<table width=_pagewidth_>
+<tr><td>
+<div class="divbar">&nbsp;</div>
+<center><h2>_textstep2_</h2></center>
+<div class="divbar">&nbsp;</div>
+<p>Filename: <input type=file name=di1userfile value="_userfile_"></p>
+<div class="divbar">&nbsp;</div>
+</td></tr>
+<tr><td>_depositorbar_</td></tr>
+</table>
+</center>
+</form>
+}
+
+#######################################################################
+# step 3
+#######################################################################
+
+#here goes the "memorization" macros for each form field.  
+#_di1_ {_If_("_:cgiargdi1md.dc.Title_" eq  "_cgiargdi1md.dc.Title_",_cgiargdi1md.dc.Title_,)}
+#_di1md.dc.Creator_ {_If_("_:cgiargdi1md.dc.Creator_" eq  "_cgiargdi1md.dc.Creator_",_cgiargdi1md.dc.Creator_,)}
+
+_step3scriptextra_ {
+
+function check\_submit (gotopage) \{
+  var form = document.depositorform;
+  form.p.value = gotopage;
+  form.submit();
+\}
+}
+
+_step3content_ {
+<form name="depositorform" method=post action="_gwcgi_" enctype="multipart/form-data">
+<input type=hidden name="e" value="_decodedcompressedoptions_">
+<input type=hidden name="p" value="_cgiargp_">
+<center>
+<table width=_pagewidth_>
+<tr><td>
+<div class="divbar">&nbsp;</div>
+<center><h2>_textstep3_</h2></center>
+<div class="divbar">&nbsp;</div>
+<p>Filename: _di1userfile_ </p>
+<p>Filesize: _di1userfilesize_ </p> 
+<div class="divbar">&nbsp;</div>
+</td></tr>
+<tr><td>_depositorbar_</td></tr>
+</table>
+</center>
+</form>
+}
+
+#######################################################################
+# bild (main frameset for build page)
+#######################################################################
+
+_bildcontent_ {
+<html>
+<head>
+<!--
+<script>
+function check\_submit (gotopage) \{
+  var form = document.depositorform;
+  form.p.value = gotopage;
+  form.submit();
+\}
+</script>
+-->
+</head>
+
+<form name="depositorform" method=post action="_gwcgi_">
+<input type=hidden name="e" value="_decodedcompressedoptions_">
+<input type=hidden name="p" value="_cgiargp_">
+
+<frameset rows="*,160" border=0>
+  <noframes><body bgcolor="#ffffff">
+  <p>You must have a frame enabled browser to obtain feedback
+  on how the building process is progressing. The collection <i>will</i>
+  continue to build as normal however.</p>
+
+  <table>
+  <tr valign=center><td>
+  To stop the building process at any time, click here.
+  <br>The collection you are working on will remain intact.
+  </td>
+  <td><input type="submit" value="stop building"></td>
+  </table>
+
+  </body>
+  </noframes>
+  <frame src="_gwcgi_?e=_compressedoptions_&p=bildframe1">
+  <frame src="_gwcgi_?e=_compressedoptions_&p=bildstatus">
+</frameset>
+</html>
+}
+
+#######################################################################
+# bildframe1
+#######################################################################
+
+# header overridden to allow base target to be set
+# also no page banner to maximise what we can fit in the frame without scrolling
+_bildframe1header_ {_cgihead_
+<html>
+<head>
+<base target=_top>
+<title>_pagetitle_</title>
+_globalscripts_
+</head>
+<body bgcolor="\#ffffff" text="\#000000" link="\#006666" 
+      alink="\#cc9900" vlink="\#666633" background="_httpiconchalk_">
+_startspacer_
+}
+
+
+_bildframe1header_[v=1] {_cgihead_
+<html>
+<head>
+<base target=_top>
+<title>_pagetitle_</title>
+_globalscripts_
+</head>
+<body bgcolor="\#ffffff" text="\#000000" link="\#006666" 
+      alink="\#cc9900" vlink="\#666633" background="_httpiconchalk_">
+}
+
+_bildframe1scriptextra_ {}
+
+_bildframe1content_ {
+<form name="depositorform" method=post action="_gwcgi_">
+<input type=hidden name="e" value="_decodedcompressedoptions_">
+<input type=hidden name="p" value="bildcancel">
+
+<center>
+<table width=_pagewidth_>
+<tr><td>
+<div class="divbar">&nbsp;</div>
+<center>
+<h2>_textbild_</h2>
+</center>
+<div class="divbar">&nbsp;</div>
+<p>
+_depositor:textbild1_
+<p>
+
+<table>
+<tr valign=center><td>
+_depositor:textbild2_
+</td>
+<td><input type="submit" value="_depositor:textstopbuild_"></td>
+</table>
+
+<p>
+_depositor:textbild3_
+</td></tr>
+</table></center>
+</form>
+}
+
+
+#######################################################################
+# bildcancel
+#######################################################################
+
+_bildcancelscriptextra_ {
+function check\_submit (gotopage) \{
+  var form = document.depositorform;
+  form.p.value = gotopage;
+  form.submit();
+\}
+}
+_bildcancelcontent_ {
+<form name="depositorform" method=post action="_gwcgi_">
+<input type=hidden name="e" value="_decodedcompressedoptions_">
+<input type=hidden name="p" value="_cgiargp_">
+
+</form>
+<center>
+<table width=_pagewidth_>
+<tr><td>
+<div class="divbar">&nbsp;</div>
+<center>
+<h2>_depositor:textbuildcancelled_</h2>
+</center>
+<div class="divbar">&nbsp;</div>
+<p>
+_depositor:textbildcancel1_
+<p><center>
+_depositorbar_
+</center>
+
+</td></tr>
+</table></center>
+}
+
+
+#######################################################################
+# bildstatus
+#######################################################################
+
+# special header for status page
+_bildstatusheader_ {_cgihead_
+_htmlhead_(background="_httpiconchalk_" onLoad="initialize();")_startspacer_
+}
+_bildstatusheader_[v=1] {_cgihead_
+_htmlhead_(onLoad="initialize();")
+}
+
+_bildstatusscriptextra_ {
+var timer = 5;
+function initialize() \{
+  setTimeout("count_down()",1000);
+\}
+
+function count_down() \{
+  if (timer==0) \{
+    window.status = "";
+    document.depositorform.submit();
+  \} else \{
+    if (timer==1) \{
+	window.status = "_textbsupdate1_";
+    \} else \{
+	window.status = "_textbsupdate2_ "+timer+" _textseconds_";
+    \}
+    timer--;
+    setTimeout("count_down()",1000);
+  \}	
+\}
+}
+
+_bildstatuscontent_ {
+<form name="depositorform" method=post action="_gwcgi_">
+<input type=hidden name="e" value="_decodedcompressedoptions_">
+
+<center>
+<table width=_pagewidth_>
+<tr><td><center>
+_statusline_
+</center>
+</td></tr>
+</table></center>
+</form>
+}
+
+
+#######################################################################
+# bilddone
+#######################################################################
+
+_bilddoneheader_ {_cgihead_
+_htmlhead_(background="_httpiconchalk_")_startspacer_
+}
+_bilddonescriptextra_ {
+
+function check\_submit (gotopage) \{
+  var form = document.depositorform;
+  form.p.value = gotopage;
+  form.submit();
+\}
+
+}
+
+
+_bilddonecontent_ {
+<center>
+<table width=_pagewidth_>
+<tr><td>
+<p>_textbildsuc_
+
+<p>_textviewbildsummary_
+
+<p><center>
+_depositorbar_
+</center>
+
+</td></tr>
+</table></center>
+}
+
+
+#######################################################################
+# bildfail
+#######################################################################
+
+_bildfailheader_ {_cgihead_
+_htmlhead_(background="_httpiconchalk_")_startspacer_
+}
+_bildfailscriptextra_ {
+function check\_submit (gotopage) \{
+  var form = document.depositorform;
+  form.p.value = gotopage;
+  form.submit();
+\}
+}
+_bildfailcontent_ {
+<form name="depositorform" method=post action="_gwcgi_">
+<input type=hidden name="e" value="_decodedcompressedoptions_">
+<input type=hidden name="p" value="_cgiargp_">
+
+</form>
+
+<table width=_pagewidth_>
+<tr><td>
+</td></tr>
+<tr><td>
+_depositorbar_
+</td></tr>
+</table></center>
+}
+
+# _textfailmsg_ will be set to one of the following macros from within
+# the server
+
+_textfailmsg1_ {
+_textfailmsg11_
+<p><center>
+_depositorbar_
+</center>
+}
+
+_textfailmsg6_ {_textfailmsg1_}
+
+_textfailmsg2_ {
+_textfailmsg21_
+<p>_textblcont_
+<p>_faillog_
+<p>_texttryagain_
+}
+
+_textfailmsg3_ {
+_textfailmsg31_
+<p>_textblcont_
+<p>_faillog_
+<p>_texttryagain_
+}
+
+_textfailmsg4_ {
+_textfailmsg41_
+<p>_textblcont_
+<p>_faillog_
+}
+
+_textfailmsg5_ {_textfailmsg4_}
+
+_textfailmsg7_ {
+_textfailmsg71_
+<p>_texttryagain_
+}
+
+#######################################################################
+# Error and message pages
+#######################################################################
+
+_messagehead_ {
+<form name="depositorform" method=post action="_gwcgi_">
+<input type=hidden name="e" value="_decodedcompressedoptions_">
+
+<center>
+<table width=_pagewidth_>
+<tr><td>
+<div class="divbar">&nbsp;</div>
+}
+
+_messagefoot_ {
+<p>
+<a href="javascript:document.depositorform.submit();">_textretcoll_</a>
+<div class="divbar">&nbsp;</div>
+</td></tr>
+</table></center>
+</form>
+}
+
+_messagefootnolink_ {
+<div class="divbar">&nbsp;</div>
+</td></tr>
+</table></center>
+</form>
+}
+
+_delpermissioncontent_ {
+_messagehead_
+<p>
+_textdelperm_
+_messagefoot_
+}
+
+_delinvalidcontent_ {
+_messagehead_
+<p>
+_textdelinv_
+_messagefoot_
+}
+
+_delsuccesscontent_ {
+_messagehead_
+<p>
+_textdelsuc_
+_messagefoot_
+}
+
+_clonefailcontent_ {
+_messagehead_
+<input type=hidden name="bc1clone" value="0">
+<p>_textclonefail_
+_messagefoot_
+}
+
+_genericcontent_ {
+_messagehead_
+<p>_textcolerr_
+_messagefoot_
+}
+
+_tmpfailcontent_ {
+_messagehead_
+<p>
+_texttmpfail_
+_messagefoot_
+}
+
+_mkcolfailcontent_ {
+_messagehead_
+<p>_textmkcolfail_
+_messagefoot_
+}
+
+_nocollectioncontent_ {
+_messagehead_
+<p>_textnocontent_
+<br><a href="_httppagedepositor_">_textrestart_</a>
+<p>
+_messagefootnolink_
+}
+
+_reloaderrorcontent_ {
+_messagehead_
+<p>_textreloaderror_
+<br><a href="_httppagedepositor_">_textrestart_</a>
+<p>
+_messagefootnolink_
+}
+
+_exptscriptextra_ {}
+
+_exptsuccesscontent_ {
+_messagehead_
+<input type=hidden name=p value=existing>
+<p>_textexptsuc_
+_messagefoot_
+}
+
+_exptfailcontent_ {
+_messagehead_
+<input type=hidden name=p value=existing>
+_textexptfail_
+_messagefoot_
+}
+
+#######################################################################
+# depositonly
+#######################################################################
+
+_depositonlyscriptextra_ {}
+
+_depositonlycontent_ {
+
+<center>
+<em>Thanks for using the Depositor! Cick <a href="_gwcgi_">here</a> to return to the Greenstone home page. </em>
+<table width=_pagewidth_>
+<tr><td>
+<div class="divbar">&nbsp;</div>
+<center><h2>_textstep3_</h2></center>
+<div class="divbar">&nbsp;</div>
+<p>Filename: _di1userfile_ </p>
+<p>Filesize: _di1userfilesize_ </p> 
+<div class="divbar">&nbsp;</div>
+</td></tr>
+<tr><td></td></tr>
+</table>
+</center>
+
+}
Index: trunk/gsdl/macros/english.dm
===================================================================
--- trunk/gsdl/macros/english.dm	(revision 11990)
+++ trunk/gsdl/macros/english.dm	(revision 11999)
@@ -64,5 +64,5 @@
 # macro will always be set to another value)
 _collectorextra_ {
-<p>This collection contains _numdocs_ _If_("_numdocs_" eq "1",document,documents), a total of _numbytes_.
+<p>This collection contains _numdocs_ _If_("_numdocs_" eq "1",document,documents), a total of _numbytes_ of indexed text and metadata.
 <p><a href="_httppagex_(bsummary)">Click here</a> to view the build summary for this collection.
 }
Index: trunk/gsdl/macros/english2.dm
===================================================================
--- trunk/gsdl/macros/english2.dm	(revision 11990)
+++ trunk/gsdl/macros/english2.dm	(revision 11999)
@@ -5,5 +5,4 @@
 # -- this file contains text that is of less importance
 ######################################################################
-
 
 
@@ -34,4 +33,8 @@
 _textdescrcollector_ {
 This predates the librarian interface, and for most practical purposes the librarian interface should be used instead
+}
+
+_textdescrdepositor_  {
+Helps you to add documents to existing collections
 }
 
@@ -269,6 +272,48 @@
 ######################################################################
 # collectoraction
+package wizard
+
+_textbild_ {Build collection}
+_textbildsuc_ {Collection built successfully.}
+_textviewbildsummary_ {
+You may <a href="_httppagex_(bsummary)&c=_cgiargbc1dirname_" target=_top>view the build
+summary</a> of this collection for further details.
+}
+_textview_ {View collection}
+
+_textbild1_ {
+The collection is now being built: this might take some time. The building
+status line below gives feedback on how the operation is progressing.
+}
+
+_textbild2_ {
+To stop the building process at any time, click here.
+<br>The collection you are working on will remain intact.
+}
+
+_textstopbuild_ {stop building}
+
+_textbild3_ {
+If you leave this page (and have not cancelled the building process with
+the "stop building" button) the collection will continue to build and will
+be installed upon successful completion.
+}
+
+_textbuildcancelled_ {Build cancelled}
+
+_textbildcancel1_ {
+The collection building process was cancelled. Use the yellow buttons below
+to make changes to your collection or restart the building process.
+}
+
+_textbsupdate1_ {Building status update in 1 second}
+_textbsupdate2_ {Building status update in}
+_textseconds_ {seconds}
+
+######################################################################
+# collectoraction
 package collector
 ######################################################################
+
 
 
@@ -283,8 +328,10 @@
 _textsrce_ {Source data}
 _textconf_ {Configure collection}
-_textbild_ {Build collection}
-_textview_ {View collection}
+_textbild_ {_wizard:textbild_}
+_textview_ {_wizard:textview_}
 _textdel_ {Delete collection}
 _textexpt_ {Export collection}
+_textbildsuc_ {_wizard:textbildsuc_}
+_textviewbildsummary_ {_wizard:textviewbildsummary_}
 
 _textdownloadingfiles_ {Downloading files ...}
@@ -497,38 +544,21 @@
 _textreset_ {Reset}
 
-_textbild1_ {
-The collection is now being built: this might take some time. The building
-status line below gives feedback on how the operation is progressing.
-}
-
-_textbild2_ {
-To stop the building process at any time, click here.
-<br>The collection you are working on will remain intact.
-}
-
-_textstopbuild_ {stop building}
-
-_textbild3_ {
-If you leave this page (and have not cancelled the building process with
-the "stop building" button) the collection will continue to build and will
-be installed upon successful completion.
-}
-
-_textbuildcancelled_ {Build cancelled}
-
-_textbildcancel1_ {
-The collection building process was cancelled. Use the yellow buttons below
-to make changes to your collection or restart the building process.
-}
-
-_textbsupdate1_ {Building status update in 1 second}
-_textbsupdate2_ {Building status update in}
-_textseconds_ {seconds}
-_textbildsuc_ {Collection built successfully.}
-
-_textviewbildsummary_ {
-You may <a href="_httppagex_(bsummary)&c=_cgiargbc1dirname_" target=_top>view the build
-summary</a> of this collection for further details.
-}
+_textbild1_ {_wizard:textbild1_}
+
+_textbild2_ {_wizard:textbild2_}
+
+_textstopbuild_ {_wizard:textstopbuild_}
+
+_textbild3_ {_wizard:textbild3_}
+
+_textbuildcancelled_ {_wizard:textbuildcancelled_}
+
+_textbildcancel1_ {_wizard:textbildcancel1_}
+
+
+_textbsupdate1_ {_wizard:textbsupdate1_}
+_textbsupdate2_ {_wizard:textbsupdate2_}
+_textseconds_ {_wizard:textseconds_}
+
 
 _textfailmsg11_ {
@@ -642,4 +672,40 @@
 }
 
+######################################################################
+# collectoraction
+package depositor
+######################################################################
+
+_textdepositor_ {The Depositor}
+
+_textdepositorblurb_ {
+
+<p> Please specify the following file information and select the file below. </p>
+
+}
+
+_textbsupdate1_ {_wizard:textbsupdate1_}
+_textbsupdate2_ {_wizard:textbsupdate2_}
+_textseconds_ {_wizard:textseconds_}
+
+_textcaec_ {Adding to an Existing Collection}
+_textbild_ {Deposit Item}
+_textintro_ {Select File}
+_textbildsuc_ {_wizard:textbildsuc_}
+_textviewbildsummary_ {_wizard:textviewbildsummary_}
+_textselect_ {Select Collection}
+_textmeta_ {Specify Metadata}
+_textview_ {_wizard:textview_}
+_textbild1_ {_wizard:textbild1_}
+
+_textbild2_ {_wizard:textbild2_}
+
+_textstopbuild_ {_wizard:textstopbuild_}
+
+_textbild3_ {_wizard:textbild3_}
+
+_textbuildcancelled_ {_wizard:textbuildcancelled_}
+
+_textbildcancel1_ {_wizard:textbildcancel1_}
 
 ######################################################################
Index: trunk/gsdl/macros/home.dm
===================================================================
--- trunk/gsdl/macros/home.dm	(revision 11990)
+++ trunk/gsdl/macros/home.dm	(revision 11999)
@@ -47,4 +47,6 @@
 _imagecollector_ {_button_(_httppagecollector_,_collector:textcollector_,_collector::textcollector_)}
 
+_imagedepositor_ {_button_(_httppagedepositor_,_depositor:textdepositor_,_depositor::textdepositor_)}
+
 _imagetranslator_ {_button_(_httppagetranslator_,_gti:textgti_)}
 
@@ -79,4 +81,5 @@
 _textgogli_
 _textgocollector_
+_textgodepositor_
 _textgotranslator_
 _textgoadmin_
@@ -112,4 +115,11 @@
 <td valign=top>_imagecollector_</td>
 <td>_textdescrcollector_</td>
+</tr>
+}
+
+_textgodepositor_ {
+<tr valign=top>
+<td valign=top>_imagedepositor_</td>
+<td>_textdescrdepositor_</td>
 </tr>
 }