Index: /trunk/gsdl3/web/interfaces/default/transform/berry.xsl
===================================================================
--- /trunk/gsdl3/web/interfaces/default/transform/berry.xsl	(revision 12024)
+++ /trunk/gsdl3/web/interfaces/default/transform/berry.xsl	(revision 12025)
@@ -13,15 +13,14 @@
   <xsl:output method="html"/>  
 
-   <xsl:param name="library_name"/>
-
+  <xsl:param name="library_name"/>
+  
    <!-- the main page layout template is here -->
   <xsl:template match="page">
     <html>
-     	 <xsl:call-template name="pageHead"/>	 
-       <body>
-         <div class='globalwraper'>
-         <xsl:apply-templates select="pageResponse"/>
-         </div>
-        	
+      <xsl:call-template name="pageHead"/>	 
+      <body>
+	<div class='globalwrapper'>
+	  <xsl:apply-templates select="pageResponse"/>
+	</div>
       </body>
     </html>
@@ -34,8 +33,8 @@
 	<xsl:call-template name="pageTitle"/>
       </title>
-        <xsl:call-template name="pageStyle"/>
+      <xsl:call-template name="pageStyle"/>
     </head>
   </xsl:template>
-
+  
   <xsl:template name="pageTitle">
     <xsl:value-of select="/page/pageResponse/serviceCluster/metadataList/metadata[@name='Title']"/>
@@ -45,54 +44,52 @@
   <!-- page specific style goes here -->
   <xsl:template name="pageStyle" >
-     <xsl:call-template name="styleSheet" />
-     <xsl:call-template name="loadLibrary" />
-     <xsl:call-template name="buildContent" />   
+    <xsl:call-template name="styleSheet" />
+    <xsl:call-template name="loadLibrary" />
+    <xsl:call-template name="buildContent" />   
     <!-- <xsl:call-template name="showMailBox" />-->
   </xsl:template>    
-
+  
   <xsl:template match="pageResponse">
     <xsl:variable name="clusterName"><xsl:value-of select="/page/pageRequest/paramList/param[@name='c']/@value"/></xsl:variable>
-      <xsl:call-template name="berryPageBanner" />
-      <xsl:apply-templates select="paramList"/>
-      <div id="content" ><span></span></div> 
-      <xsl:call-template name="footBanner" />
-   </xsl:template>
-  
-
-<xsl:template match="collection">
-   
+    <xsl:call-template name="berryPageBanner" />
+    <xsl:apply-templates select="paramList"/>
+    <div id="content" ><span></span></div> 
+    <xsl:call-template name="footBanner" />
+  </xsl:template>
+  
+
+  <xsl:template match="collection">
     <xsl:for-each select="item">
-       <xsl:text disable-output-escaping="yes">
-          var  doc = new Array();             
-          </xsl:text>
-           <xsl:for-each select="@*">
-                <xsl:text disable-output-escaping="yes">
-                 doc["</xsl:text><xsl:value-of select="name()" /><xsl:text disable-output-escaping="yes">"]='</xsl:text><xsl:value-of select="." /><xsl:text disable-output-escaping="yes">'; </xsl:text>   
-           </xsl:for-each>
-          <xsl:text disable-output-escaping="yes"> 
-           docList[docList.length] = doc; 
-        </xsl:text>  
-      </xsl:for-each>     
-   </xsl:template>
-
-
- <xsl:template name="buildContent">
-   <script type="text/javascript">
       <xsl:text disable-output-escaping="yes">
-       var previousView;
-       var docList = new Array();
-       var urlonly = false;
-       var mailinfo = new Array();
-       mailinfo['address'] = "To: ";
-       mailinfo['cc'] = "CC: ";
-       mailinfo['bcc'] = "Bcc: ";
-       mailinfo['subject'] = "Subject: "; 
-       var textwin;
-       var mailwin;
- 
+	var  doc = new Array();             
       </xsl:text>
-     <xsl:apply-templates select="/page/pageResponse/collection" />       
-     
-     <xsl:text disable-output-escaping="yes">
+      <xsl:for-each select="@*">
+	<xsl:text disable-output-escaping="yes">
+	  doc["</xsl:text><xsl:value-of select="name()" /><xsl:text disable-output-escaping="yes">"]='</xsl:text><xsl:value-of select="." /><xsl:text disable-output-escaping="yes">'; </xsl:text>   
+      </xsl:for-each>
+      <xsl:text disable-output-escaping="yes"> 
+	docList[docList.length] = doc; 
+      </xsl:text>  
+    </xsl:for-each>     
+  </xsl:template>
+  
+  
+  <xsl:template name="buildContent">
+    <script type="text/javascript">
+      <xsl:text disable-output-escaping="yes">
+	var previousView;
+	var docList = new Array();
+	var urlonly = false;
+	var mailinfo = new Array();
+	mailinfo['address'] = "To: ";
+	mailinfo['cc'] = "CC: ";
+	mailinfo['bcc'] = "Bcc: ";
+	mailinfo['subject'] = "Subject: "; 
+	var textwin;
+	var mailwin;
+      </xsl:text>
+      <xsl:apply-templates select="/page/pageResponse/collection" />       
+      
+      <xsl:text disable-output-escaping="yes">
     
        function navigate(e){   
@@ -507,28 +504,28 @@
       </xsl:text>
     </script>    
- </xsl:template>
+  </xsl:template>
 
   <xsl:template name="styleSheet">
-        <link rel="stylesheet" href="interfaces/default/style/core.css" type="text/css"/>  
-        <link rel="stylesheet" href="interfaces/default/style/berry.css" type="text/css"/>  
-  </xsl:template>
-
+    <link rel="stylesheet" href="interfaces/default/style/core.css" type="text/css"/>  
+    <link rel="stylesheet" href="interfaces/default/style/berry.css" type="text/css"/>  
+  </xsl:template>
+  
   <xsl:template name="showMailBox">
-     <script type="text/javascript">
-       <xsl:text disable-output-escaping="yes">
-            var show = false;	
-	    var table;
-            var mailserver  = new Array();     
-            mailserver['host'] = "Mail Server: ";
-            mailserver['user'] = "User Name: ";
-            mailserver['password'] = "Password: ";
-           
-            var mailinfo = new Array();
-            mailinfo['address'] = "To: ";
-            mailinfo['cc'] = "CC: ";
- 	    mailinfo['bcc'] = "Bcc: ";
-            mailinfo['subject'] = "Subject: "; 
-
-           function mailBoxUpdate(e) {
+    <script type="text/javascript">
+      <xsl:text disable-output-escaping="yes">
+	var show = false;	
+	var table;
+	var mailserver  = new Array();     
+	mailserver['host'] = "Mail Server: ";
+	mailserver['user'] = "User Name: ";
+	mailserver['password'] = "Password: ";
+	
+	var mailinfo = new Array();
+	mailinfo['address'] = "To: ";
+	mailinfo['cc'] = "CC: ";
+	mailinfo['bcc'] = "Bcc: ";
+	mailinfo['subject'] = "Subject: "; 
+	
+	function mailBoxUpdate(e) {
 		var target = e.target;
 		if (target.id.toLowerCase() == 'sendasemail' &amp;&amp; !show){
@@ -715,32 +712,32 @@
             YAHOO.util.Event.addListener(window,'click',mailBoxUpdate );
 
-       </xsl:text> 
-     </script>
-    </xsl:template>
-
+      </xsl:text> 
+    </script>
+  </xsl:template>
+  
   <xsl:template name="berryPageBanner">
     <div class='banner'>
-        <div class='pageinfo'>
-           <p class='bannerlinks'>
-              <a class='navlink' href='{$library_name}?a=p&amp;sa=home' title='Library home page' >HOME</a>
-             <a class='navlink' href='{$library_name}?a=p&amp;sa=help&amp;c='  title='Help pages' >HELP</a>
-             <a class='navlink' href='{$library_name}?a=p&amp;sa=pref&amp;c=' title='Change your interface preferences'>PREFERENCES</a>
-              </p>      
-       </div>
-       <div class='basketimage'><p class='bannertitle'>Berry Basket</p></div>        
-   </div>
+      <div class='pageinfo'>
+	<p class='bannerlinks'>
+	  <a class='navlink' href='{$library_name}?a=p&amp;sa=home' title='Library home page' >HOME</a>
+	  <a class='navlink' href='{$library_name}?a=p&amp;sa=help&amp;c='  title='Help pages' >HELP</a>
+	  <a class='navlink' href='{$library_name}?a=p&amp;sa=pref&amp;c=' title='Change your interface preferences'>PREFERENCES</a>
+	</p>      
+      </div>
+      <div class='basketimage'><p class='bannertitle'>Berry Basket</p></div>        
+    </div>
     <div class="bannerextra"></div>
- 
+    
     <div >
-       <p class='navbar'><span id='fullview' class='navlink'>full view</span><span id='textview' class='navlink'>plain text version</span><span id='email' class='navlink'>email to a friend</span></p>
+      <p class='navbar'><span id='fullview' class='navlink'>full view</span><span id='textview' class='navlink'>plain text version</span><span id='email' class='navlink'>email to a friend</span></p>
     </div> 
   </xsl:template>
-
- <xsl:template name="footBanner">
+  
+  <xsl:template name="footBanner">
     <div >
-       <p class='navbar'><span >powered by greenstone3</span></p>
+      <p class='navbar'><span >powered by greenstone3</span></p>
     </div> 
   </xsl:template>
-    
+  
 </xsl:stylesheet>  
 