Index: /trunk/gli/src/org/greenstone/gatherer/gui/CreatePane.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/gui/CreatePane.java	(revision 12066)
+++ /trunk/gli/src/org/greenstone/gatherer/gui/CreatePane.java	(revision 12067)
@@ -49,5 +49,5 @@
 import org.greenstone.gatherer.Gatherer;
 import org.greenstone.gatherer.LocalLibraryServer;
-import org.greenstone.gatherer.cdm.SearchTypeManager;
+import org.greenstone.gatherer.cdm.BuildTypeManager;
 import org.greenstone.gatherer.cdm.CollectionDesignManager;
 import org.greenstone.gatherer.collection.Collection;
@@ -148,5 +148,5 @@
     private String args[] = null;
     /** The homepage address of the current collection */
-    private String homepage = null;
+    public String homepage = null;
 
 
@@ -208,6 +208,5 @@
 	BuildButtonListener bbl = new BuildButtonListener();
 	CancelButtonListener cbl = new CancelButtonListener();
-	PreviewButtonListener pbl = new PreviewButtonListener();
-
+	
 	build_button = new GLIButton();
 	build_button.addActionListener(bbl);
@@ -221,6 +220,6 @@
 	Dictionary.registerBoth(cancel_button, "CreatePane.Cancel_Build", "CreatePane.Cancel_Build_Tooltip");
 
-	preview_button = new GLIButton();
-	preview_button.addActionListener(pbl);
+	preview_button = new PreviewButton();
+	//preview_button.addActionListener(pbl);
 	if(Gatherer.c_man != null) {
 	    preview_button.setEnabled(Gatherer.c_man.built());
@@ -243,6 +242,6 @@
 	Dictionary.registerBoth(simple_cancel_button, "CreatePane.Cancel_Build", "CreatePane.Cancel_Build_Tooltip");
 
-	simple_preview_button = new GLIButton();
-	simple_preview_button.addActionListener(pbl);
+	simple_preview_button = new PreviewButton();
+	//simple_preview_button.addActionListener(pbl);
 	if(Gatherer.c_man != null) {
 	    simple_preview_button.setEnabled(Gatherer.c_man.built());
@@ -256,5 +255,5 @@
 	bbl = null;
 	cbl = null;
-	pbl = null;
+	//pbl = null;
     }
 
@@ -630,40 +629,4 @@
 	}
     }
-
-
-    private void configureHomeURL() {	
-	// set up the home page for the current collection
-	Collection current_collection = Gatherer.c_man.getCollection();
-	String site = Configuration.site_name; // for GS3 colls
-	String extra_args = "";
-	SearchTypeManager st_man = current_collection.cdm.searchtype_manager;
-	if (!Gatherer.GS3 && st_man.isSearchTypeEnabled()) {
-	    if (st_man.isLucene()) {
-		extra_args = "&ct=2";
-	    } else { // MGPP default
-		extra_args = "&ct=1";
-	    }
-	    // we need some more args on the url
-	    String search_types = st_man.getSearchTypes();
-	    if (search_types.equals("")) {
-		extra_args += "&qt=0&qto=3";
-	    } else if (search_types.equals("plain")) {
-		extra_args += "&qt=0&qto=1";
-	    } else if (search_types.equals("form")) {
-		extra_args += "&qt=1&qto=2";
-	    } else if (search_types.equals("plain,form")) {
-		extra_args += "&qt=0&qto=3";
-	    } else if (search_types.equals("form,plain")) {
-		extra_args += "&qt=1&qto=3";
-	    }
-	}
-	// Remember to add unique timestamp
-	if (Gatherer.GS3) {
-	    homepage = Configuration.library_url.toString() + Configuration.getServletPath()+ "?a=p&sa=about&c=" + current_collection.getName()+"&l="+Configuration.getLanguage(); //+extra_args + StaticStrings.TIMESTAMP_ARGUMENT + System.currentTimeMillis();
-	} else {
-	    homepage = Configuration.library_url.toString() + "?a=p&p=about&c=" + current_collection.getName()+"&l="+Configuration.getLanguage()+extra_args + StaticStrings.TIMESTAMP_ARGUMENT + System.currentTimeMillis();
-	}
-    }
-    
 
     /** This class serves as the listener for actions on the build button. */
@@ -793,17 +756,4 @@
     }
 
-    private class PreviewButtonListener
-	implements ActionListener {
-	
-	public void actionPerformed(ActionEvent event) {
-	    Gatherer.c_man.getCollection().cdm.save(); // save the config file just in case
-	    configureHomeURL();
-	    // check that the local library server is stil running  - doesn't do anything if its not supposed to be running
-	    LocalLibraryServer.checkServerRunning();
-	    
-	    Gatherer.spawnBrowser(homepage);
-
-	}
-    }
     
     /** The OptionTree is simply a tree structure that has a root node labelled "Options" and then has a child node for each available options screen. These screens are either combinations of the available import and build arguments, or a message log detailing the shell processes progress. */
@@ -900,5 +850,5 @@
 		}
 	    }
-				//scroll_pane.setViewportView(previous_pane);
+	    //scroll_pane.setViewportView(previous_pane);
 	    //previous_pane.validate();
 	    right.validate();